%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  52. polygons.m  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% script file  polygons.m
% Start command: M, polygons;
% M=the number of polygons in the sequence; m=1:M;

% s= the number of gytes used in the computations (given below by emp.form.)
% n=the number of vertices of the polygon; n=6*2^(m-1);
% p(m+1)=circumference of the mth polygon; set q=p/n;
% We seek lim_(m-->oo) p(m+1)
% Recurrence relation for p(m) given in Dahlquist-Bjoerck Latex version
% Example 3.3.19. This becomes the following recurrence relations for q and n:
%  q := q/ sqrt(2+sqrt(4-q^2));   n:=2*n;

% Initial values:
s=ceil(exp(1.585*log(M)-1.475)),
% Empirical formula for s from experiments with a slightly different code.
% Should be reexamined.
n=6; p=zeros(M,s);   p(1,:)=[2-s 6 zeros(1,s-2)];  q=1;

%
 for m=1:M,
    t1=musqrt(sub(4,mul(q,q,s)),s);
    t2=musqrt(add(2,t1),s);
    q=div(q,t2,s);
    n=mul(2,n);
    p(m+1,:)=mul(n,q,s);
 end
 lastrow=p(M+1,:)                %temporary print
 bottom=rich3(p);    % disp('R is equal to bottom.')
