%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  51. rich3.m  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

  function [bottom, diago, z]=rich3(x,pri,K);
%
%   Richardson h^2-extrapolation, of the mulprec vector x, repeated K-1
% times. The number of  rows of x is denoted M.
% R contains the bottom elements of the Richardson scheme, up to col.K.
% z contains the elements of col.K below and on the diagonal (if K<M ).
% pri=1 gives also print of the bottom element of each column.
% pri=0 gives only (short) print of each correction in the
% last row.
% z, pri and K are optional. By default, K=M, pri=0.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  tic
  global P
  [M,s] =size(x),
  Rnew=x;
  if nargin<3, K=M;       end
  if nargin<2, pri=0;     end

  bottom=zeros(size(x)); % diago=zeros(size(x));
  bottom(1,:)=Rnew(M,:); % diago(1,:)=Rnew(1,:);
  k=1; fac=1; bocorold=P^(x(1,1)+s); bocor=bocorold/2;
  %
  while (abs(bocor)<abs(bocorold))&(k<100)
    k=k+1,
    fac=4*fac;  tmf=recip(1-fac,s+1); tmc=nize(sub(1,tmf));
    Rold=Rnew;
    t0=adv( musv(tmc,Rold(2:M-k+2,:),s), musv(tmf,Rold(1:M-k+1,:),s) );
    Rnew=choprnizev(t0,s);     %size=[M-k+1,s]
    bottom(k,:)=Rnew(M-k+1,:);                 %
    bocorold=bocor;
    bocor = flo(nize(sub( bottom(k,:), bottom(k-1,:) ) ));
    format short e, disp('bottom correction ='), disp(bocor),
   %diago(k,:)=Rnew(1,:);
   %diacor =flo(nize(sub(  diago(k,:),  diago(k-1,:) ) ));
   %disp('diagonal correction ='), disp(diacor),
  end
  lastk=k,
  bottom,
  if lastk<M,  z=Rnew(1:M-lastk+1,:); end
